
#
# Approach 1: create and sort a "parallel array"
#             containing the column numbers
#

col_input   = [1, 1, 3]
col_numbers = range(len(col_input))

def compare(col_a, col_b):
    if col_input[col_a] < col_input[col_b]:
        return -1
    elif col_input[col_a] > col_input[col_b]:
        return 1
    else:
        return 0

sorted_columns = sorted( col_numbers, \
                         cmp=compare, \
                         reverse=True )
print sorted_columns

#
# Approach 2: zip column_input with column numbers,
#             then sort by the second field in tuple
#

col_input = [1, 1, 3]

print zip( range(len(col_input)), col_input )

zipped_columns = zip( range(len(col_input)), col_input )
sorted_columns = sorted( zipped_columns, \
                         key=lambda pair: pair[1], \
                         reverse=True )

print sorted_columns

#
# Approach 3: make a Column object that tracks both
#             the column number and the corresponding
#             value from column_input ... use list of
#             Columns and sort by value
#

col_input = [1, 1, 3]

class Column:
  def __init__(self, num, val):
    self.number = num
    self.value  = val
  def __str__(self):
    return "(" + str(self.number) + "," + str(self.value) + ")"

def process_cols(column_values):
  result = []
  for i in range(len(column_values)):
    result.append( Column(i, column_values[i]) )
  return result

# print process_cols(col_input)

def compare(Col_a, Col_b):
    if Col_a.value < Col_b.value:
        return -1
    elif Col_a.value > Col_b.value:
        return 1
    else:
        return 0

def pr(x):
  print x

sorted_columns = sorted( process_cols(col_input), \
                         cmp=compare, \
                         reverse=True )

for i in range(len(sorted_columns)):
  print sorted_columns[i]

